"use strict";

require("core-js/modules/es.reflect.construct.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.proxyMethod = exports.extendConstructor = void 0;
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.index-of.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.function.name.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.get-own-property-names.js");
require("core-js/modules/es.object.get-prototype-of.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.promise.js");
require("core-js/modules/es.promise.finally.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _type = require("./type");
function _callSuper(t, o, e) { return o = (0, _getPrototypeOf2["default"])(o), (0, _possibleConstructorReturn2["default"])(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2["default"])(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var failQuitely = function failQuitely(func, args) {
  try {
    return func.apply(void 0, (0, _toConsumableArray2["default"])(args));
  } catch (e) {}
};
var invokeMethod = function invokeMethod(instance, method, proto, propertyName, args, hanlder) {
  var context = {};
  failQuitely(hanlder, [{
    type: _type.InvocationEventType.PRE,
    arguments: args,
    method: propertyName,
    "class": proto.constructor.__$$className || proto.constructor.name,
    context: context
  }]);

  // provide a way for invoking method regardless it is async or sync function, attach the return value and the error(if it occurred) to the event object
  var returnVal = method.apply(instance, args);
  var post = function post(val, error) {
    failQuitely(hanlder, [{
      type: _type.InvocationEventType.POST,
      arguments: args,
      "return": val,
      method: propertyName,
      "class": proto.constructor.__$$className || proto.constructor.name,
      context: context,
      error: error
    }]);
  };
  var isThenable = returnVal && !!returnVal.then;
  if (isThenable) {
    // capture async return and potential error
    var rtnTemp, errTemp;
    returnVal.then(function (r) {
      rtnTemp = r;
    })["catch"](function (e) {
      errTemp = e;
    })["finally"](function () {
      post(rtnTemp, errTemp);
    });
  } else {
    post(returnVal);
  }
  return returnVal;
};
var proxyMethod = exports.proxyMethod = function proxyMethod(method, proto, propertyName, handler) {
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    return invokeMethod(this, method, proto, propertyName, args, handler);
  };
};
var getMethods = function getMethods(target) {
  var allProps = [];
  var allMethods = [];
  var curr = target;
  while ((curr = Object.getPrototypeOf(curr)) && curr !== Object.prototype) {
    var props = Object.getOwnPropertyNames(curr);
    props.forEach(function (prop) {
      if (allProps.indexOf(prop) === -1) {
        allProps.push(prop);
        if (prop === 'constructor') {
          return;
        }
        try {
          if (typeof target[prop] === 'function') {
            allMethods.push(prop);
          }
        } catch (e) {
          var descptor = Object.getOwnPropertyDescriptor(curr, prop);
          if (typeof (descptor === null || descptor === void 0 ? void 0 : descptor.value) === 'function') {
            // it's a method of a class
            allMethods.push(prop);
          } else {
            // Logger.info('undetermined type of property', descptor, curr, prop);
          }
        }
      }
    });
  }
  return allMethods;
};
var extendConstructor = exports.extendConstructor = function extendConstructor(constructor, handler, extendProps, proxyMethods) {
  var _Class;
  return _Class = /*#__PURE__*/function (_constructor) {
    function _Class() {
      var _this;
      (0, _classCallCheck2["default"])(this, _Class);
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      _this = _callSuper(this, _Class, [].concat(args));
      if (proxyMethods) {
        var methods = getMethods(_this);
        // proxy methods
        // redefine methods on the instance
        methods.forEach(function (propertyName) {
          var method = _this[propertyName];
          Object.defineProperty(_this, propertyName, {
            writable: true,
            configurable: true,
            enumerable: false,
            value: proxyMethod(method, _this, propertyName, handler)
          });
        });
      }

      // mount extend properties
      Object.keys(extendProps).forEach(function (propertyName) {
        Object.defineProperty(_this, propertyName, {
          configurable: true,
          enumerable: false,
          writable: false,
          value: extendProps[propertyName]
        });
      });
      return _this;
    }
    (0, _inherits2["default"])(_Class, _constructor);
    return (0, _createClass2["default"])(_Class);
  }(constructor), (0, _defineProperty2["default"])(_Class, "__$$className", constructor.name), _Class;
};