import { Interceptor } from '../utilities/interceptor';
export declare enum InvocationEventType {
    PRE = 0,
    POST = 1
}
export type InvocationEvent = {
    type: InvocationEventType;
    context: Record<string, any>;
    class: string;
    method: string;
    arguments?: any[];
    return?: any;
    error?: Error;
};
export type InvocationHandler = Interceptor<InvocationEvent>;
export type AnyFunction = (...args: any) => any;
