"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setupConsoleHijack = exports.restoreConsoleHijack = exports.originConsole = void 0;
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.index-of.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/esnext.async-iterator.filter.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.filter.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var methods = ['info', 'error', 'warn', 'debug'];
var originConsole = exports.originConsole = window.console;
var setupConsoleHijack = exports.setupConsoleHijack = function setupConsoleHijack(logger) {
  var console = _objectSpread({}, originConsole);
  //@ts-ignore
  if (console.__hijackSetup) {
    console.log('[logger] hijack already setup!');
    return;
  }
  console.log("[logger] setup hijack..");
  function proxy(methodName) {
    return function () {
      switch (methodName) {
        case 'debug':
          logger.debug.apply(logger, arguments);
          break;
        case 'info':
          logger.info.apply(logger, arguments);
          break;
        case 'warn':
          logger.warn.apply(logger, arguments);
          break;
        case 'error':
          logger.error.apply(logger, arguments);
          break;
      }
    };
  }
  Object.keys(console).filter(function (e) {
    return methods.indexOf(e) >= 0;
  }).forEach(function (methodName) {
    console[methodName] = proxy(methodName);
  });
  //@ts-ignore
  console.__hijackSetup = true;
  window.console = console;
};
var restoreConsoleHijack = exports.restoreConsoleHijack = function restoreConsoleHijack() {
  console.log("[logger] restore hijack..");
  window.console = originConsole;
  //@ts-ignore
  console.__hijackSetup = false;
};