"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoggerImpl = void 0;
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.array.join.js");
require("core-js/modules/es.array.unshift.js");
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _upperCase = _interopRequireDefault(require("lodash/upperCase"));
var _dayjs = _interopRequireDefault(require("dayjs"));
var _constants = require("./constants");
var _type = require("./type");
var _hijack = require("./hijack");
var _padEnd = _interopRequireDefault(require("lodash/padEnd"));
var LoggerImpl = exports.LoggerImpl = /*#__PURE__*/function () {
  function LoggerImpl(_label, _dest, _logLevel, _logWorkerInteractor) {
    (0, _classCallCheck2["default"])(this, LoggerImpl);
    this._label = _label;
    this._dest = _dest;
    this._logLevel = _logLevel;
    this._logWorkerInteractor = _logWorkerInteractor;
  }
  return (0, _createClass2["default"])(LoggerImpl, [{
    key: "setLogLevel",
    value: function setLogLevel(logLevel) {
      this._logLevel = logLevel;
    }
  }, {
    key: "debug",
    value: function debug() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      this._log.apply(this, [_type.LogLevel.DEBUG].concat(args));
    }
  }, {
    key: "info",
    value: function info() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      this._log.apply(this, [_type.LogLevel.INFO].concat(args));
    }
  }, {
    key: "warn",
    value: function warn() {
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }
      this._log.apply(this, [_type.LogLevel.WARN].concat(args));
    }
  }, {
    key: "error",
    value: function error() {
      for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }
      this._log.apply(this, [_type.LogLevel.ERROR].concat(args));
    }
  }, {
    key: "_log",
    value: function _log(logLevel) {
      if (logLevel > this._logLevel) {
        return;
      }
      // prepend log level to second position of the log message
      for (var _len5 = arguments.length, args = new Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
        args[_key5 - 1] = arguments[_key5];
      }
      args.unshift((0, _padEnd["default"])((0, _upperCase["default"])(_constants.logLevelMap[logLevel] || 'unknown'), 5, ' '));
      // prepend log level to first position of the log message
      args.unshift((0, _dayjs["default"])().format('YYYY-MM-DD HH:mm:ss'));
      if (this._dest.database) {
        this._pipeToDatabase(args.join(' '));
      }
      if (this._dest.console) {
        this._pipeToConsole(logLevel, args);
      }
    }
  }, {
    key: "_pipeToDatabase",
    value: function _pipeToDatabase(message) {
      this._logWorkerInteractor.sendLog(message, this._label);
    }
  }, {
    key: "_pipeToConsole",
    value: function _pipeToConsole(logLevel, args) {
      var console = _hijack.originConsole;
      switch (logLevel) {
        case _type.LogLevel.DEBUG:
          console.debug.apply(console, (0, _toConsumableArray2["default"])(args));
          break;
        case _type.LogLevel.INFO:
          console.info.apply(console, (0, _toConsumableArray2["default"])(args));
          break;
        case _type.LogLevel.WARN:
          console.warn.apply(console, (0, _toConsumableArray2["default"])(args));
          break;
        case _type.LogLevel.ERROR:
          console.error.apply(console, (0, _toConsumableArray2["default"])(args));
          break;
      }
    }
  }]);
}();