"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PollingTask = exports.IntervalTask = exports.ActionWhenTaskFail = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
require("core-js/modules/es.error.cause.js");
require("core-js/modules/es.error.to-string.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.promise.js");
require("core-js/modules/web.timers.js");
var ActionWhenTaskFail = exports.ActionWhenTaskFail = /*#__PURE__*/function (ActionWhenTaskFail) {
  ActionWhenTaskFail[ActionWhenTaskFail["CONTINUE"] = 0] = "CONTINUE";
  ActionWhenTaskFail[ActionWhenTaskFail["EXIT"] = 1] = "EXIT";
  return ActionWhenTaskFail;
}({});
var promisify = function promisify(runnable) {
  return new Promise(/*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(resolve, reject) {
      var v;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return runnable();
          case 3:
            v = _context.sent;
            resolve(v);
            _context.next = 10;
            break;
          case 7:
            _context.prev = 7;
            _context.t0 = _context["catch"](0);
            reject(_context.t0);
          case 10:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 7]]);
    }));
    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }());
};
var PollingTask = exports.PollingTask = /*#__PURE__*/function () {
  function PollingTask(__arguments) {
    (0, _classCallCheck2["default"])(this, PollingTask);
    (0, _defineProperty2["default"])(this, "__running", false);
    this.__arguments = __arguments;
  }
  return (0, _createClass2["default"])(PollingTask, [{
    key: "start",
    value: function start() {
      var _this = this;
      if (this.__running) {
        throw new Error('Task is already running');
      }
      this.__running = true;
      if (this.__arguments.immediate) {
        promisify(this.__arguments.runnable).then(function () {
          _this.poll();
        });
      } else {
        this.poll();
      }
    }
  }, {
    key: "poll",
    value: function poll() {
      var _this2 = this;
      if (!this.__running) {
        return this.stop();
      }
      this.__timer = setTimeout(/*#__PURE__*/(0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return promisify(_this2.__arguments.runnable)["catch"](function (err) {
                var action = _this2.__arguments.onFail(err);
                if (action === ActionWhenTaskFail.EXIT) {
                  _this2.__running = false;
                }
              });
            case 2:
              !_this2.__arguments.once && _this2.poll();
            case 3:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      })), this.__arguments.interval);
    }
  }, {
    key: "stop",
    value: function stop() {
      clearTimeout(this.__timer);
      this.__running = false;
    }
  }, {
    key: "isStopped",
    get: function get() {
      return !this.__running;
    }
  }]);
}();
var IntervalTask = exports.IntervalTask = /*#__PURE__*/function () {
  function IntervalTask(__arguments) {
    (0, _classCallCheck2["default"])(this, IntervalTask);
    (0, _defineProperty2["default"])(this, "__running", false);
    this.__arguments = __arguments;
  }
  return (0, _createClass2["default"])(IntervalTask, [{
    key: "start",
    value: function start() {
      var _this3 = this;
      if (this.__running) {
        throw new Error('Task is already running');
      }
      this.__running = true;
      var _this$__arguments = this.__arguments,
        immediate = _this$__arguments.immediate,
        interval = _this$__arguments.interval;
      if (immediate) {
        this.poll();
      }
      this.__timer = setInterval(function () {
        _this3.poll();
      }, interval);
    }
  }, {
    key: "poll",
    value: function poll() {
      var _this4 = this;
      if (!this.__running) {
        return this.stop();
      }
      var runnable = this.__arguments.runnable;
      promisify(runnable)["catch"](function (err) {
        var action = _this4.__arguments.onFail(err);
        if (action === ActionWhenTaskFail.EXIT) {
          _this4.__running = false;
        }
      });
    }
  }, {
    key: "stop",
    value: function stop() {
      clearInterval(this.__timer);
      this.__running = false;
    }
  }, {
    key: "isStopped",
    get: function get() {
      return !this.__running;
    }
  }]);
}();