"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AgoraUploadScheduler = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.array.unshift.js");
require("core-js/modules/es.function.bind.js");
require("core-js/modules/web.timers.js");
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _events = require("../utilities/events");
var AgoraUploadScheduler = exports.AgoraUploadScheduler = /*#__PURE__*/function () {
  function AgoraUploadScheduler(_uploadHandler) {
    (0, _classCallCheck2["default"])(this, AgoraUploadScheduler);
    (0, _defineProperty2["default"])(this, "_eventEmitter", new _events.AgoraEventEmitter());
    (0, _defineProperty2["default"])(this, "_taskQueue", []);
    (0, _defineProperty2["default"])(this, "_isProcessing", false);
    (0, _defineProperty2["default"])(this, "_retryDelay", 1000);
    (0, _defineProperty2["default"])(this, "_stopped", false);
    this._uploadHandler = _uploadHandler;
    this._notifyQueueChanged = this._notifyQueueChanged.bind(this);
  }
  return (0, _createClass2["default"])(AgoraUploadScheduler, [{
    key: "release",
    value: function release() {
      this._stopped = true;
      this._taskQueue = [];
    }
  }, {
    key: "setRetryDelay",
    value: function setRetryDelay(delay) {
      this._retryDelay = delay;
    }
  }, {
    key: "addUploadTask",
    value: function addUploadTask(task) {
      this._taskQueue.push(task);
      this._notifyQueueChanged();
    }
  }, {
    key: "prependUploadTask",
    value: function prependUploadTask(task) {
      this._taskQueue.unshift(task);
      this._notifyQueueChanged();
    }
  }, {
    key: "addObserver",
    value: function addObserver(observer) {
      if (observer.onUploadFailure) {
        this._eventEmitter.on('upload-failure', observer.onUploadFailure);
      }
      if (observer.onUploadSuccess) {
        this._eventEmitter.on('upload-success', observer.onUploadSuccess);
      }
    }
  }, {
    key: "removeObserver",
    value: function removeObserver(observer) {
      if (observer.onUploadFailure) {
        this._eventEmitter.off('upload-failure', observer.onUploadFailure);
      }
      if (observer.onUploadSuccess) {
        this._eventEmitter.off('upload-success', observer.onUploadSuccess);
      }
    }
  }, {
    key: "_notifyQueueChanged",
    value: function () {
      var _notifyQueueChanged2 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var task;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (!this._stopped) {
                _context.next = 2;
                break;
              }
              return _context.abrupt("return");
            case 2:
              if (!this._isProcessing) {
                _context.next = 4;
                break;
              }
              return _context.abrupt("return");
            case 4:
              if (!(this._taskQueue.length !== 0 && (task = this._taskQueue.shift()))) {
                _context.next = 20;
                break;
              }
              _context.prev = 5;
              this._isProcessing = true;
              _context.next = 9;
              return this._uploadHandler.handleUpload(task);
            case 9:
              this._eventEmitter.emit('upload-success', task);
              _context.next = 16;
              break;
            case 12:
              _context.prev = 12;
              _context.t0 = _context["catch"](5);
              this._eventEmitter.emit('upload-failure', _context.t0, task);
              this._taskQueue.unshift(task);
            case 16:
              _context.prev = 16;
              this._isProcessing = false;
              setTimeout(this._notifyQueueChanged, this._retryDelay);
              return _context.finish(16);
            case 20:
            case "end":
              return _context.stop();
          }
        }, _callee, this, [[5, 12, 16, 20]]);
      }));
      function _notifyQueueChanged() {
        return _notifyQueueChanged2.apply(this, arguments);
      }
      return _notifyQueueChanged;
    }()
  }]);
}();