"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/esnext.async-iterator.filter.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.filter.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.retryAttempt = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.promise.js");
require("core-js/modules/web.timers.js");
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _asyncAwaitRetry = _interopRequireDefault(require("async-await-retry"));
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Retry = /*#__PURE__*/function () {
  /**
   * @param fn target function
   * @param args arguments the target function to be called with
   * @param opts options
   */
  function Retry(fn, args, opts) {
    (0, _classCallCheck2["default"])(this, Retry);
    this.fn = fn;
    this.args = args;
    this.opts = opts;
  }

  /**
   *
   * Registers a callback to be called when the target function fails
   * This callback function can be used to manage, by yourself, the retry system. It's called when an error occurred and before to retry. This method can have three behaviors:
   * you can throw an error
   * if it returns truthy value then normal retry system continues
   * if it returns falsy value then the retry system stop
   *
   * @param fn callback function to be called
   * @returns
   */
  return (0, _createClass2["default"])(Retry, [{
    key: "fail",
    value: function fail(fn) {
      this.onRetryAttemptFail = fn;
      return this;
    }

    /**
     * Registers a callback to be called when the target function and all retries fail
     *
     * @param fn callback function to be called
     * @returns
     */
  }, {
    key: "abort",
    value: function abort(fn) {
      this.onRetryAbort = fn;
      return this;
    }

    /**
     * Starts executes the target function
     * retriesMax would be 3 and maxBackoff would be 10000(10 sceonds) by default
     */
  }, {
    key: "exec",
    value: (function () {
      var _exec = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        var _this = this;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              _context3.next = 3;
              return (0, _asyncAwaitRetry["default"])(this.fn, this.args, _objectSpread(_objectSpread({
                retriesMax: 3,
                maxBackoff: 10000,
                interval: 1000
              }, this.opts), {}, {
                onAttemptFail: function () {
                  var _onAttemptFail = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2(data) {
                    var timeFn;
                    return _regenerator["default"].wrap(function _callee2$(_context2) {
                      while (1) switch (_context2.prev = _context2.next) {
                        case 0:
                          timeFn = /*#__PURE__*/function () {
                            var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
                              var interval;
                              return _regenerator["default"].wrap(function _callee$(_context) {
                                while (1) switch (_context.prev = _context.next) {
                                  case 0:
                                    interval = data.exponential ? Math.min(Math.pow(data.factor, data.currentRetry) * data.interval, data.maxBackoff) : data.interval; // if interval is set to zero, do not use setTimeout, gain 1 event loop tick
                                    if (!interval) {
                                      _context.next = 4;
                                      break;
                                    }
                                    _context.next = 4;
                                    return new Promise(function (r) {
                                      return setTimeout(r, interval + data.jitter);
                                    });
                                  case 4:
                                  case "end":
                                    return _context.stop();
                                }
                              }, _callee);
                            }));
                            return function timeFn() {
                              return _ref.apply(this, arguments);
                            };
                          }();
                          _context2.t0 = _this.onRetryAttemptFail;
                          if (!_context2.t0) {
                            _context2.next = 6;
                            break;
                          }
                          _context2.next = 5;
                          return _this.onRetryAttemptFail(_objectSpread(_objectSpread({}, data), {}, {
                            // fix issue of currentRetry starting from 0
                            currentRetry: data.currentRetry + 1,
                            timeFn: timeFn
                          }));
                        case 5:
                          _context2.t0 = _context2.sent;
                        case 6:
                          return _context2.abrupt("return", _context2.t0);
                        case 7:
                        case "end":
                          return _context2.stop();
                      }
                    }, _callee2);
                  }));
                  function onAttemptFail(_x) {
                    return _onAttemptFail.apply(this, arguments);
                  }
                  return onAttemptFail;
                }()
              }));
            case 3:
              _context3.next = 12;
              break;
            case 5:
              _context3.prev = 5;
              _context3.t0 = _context3["catch"](0);
              _context3.t1 = this.onRetryAbort;
              if (!_context3.t1) {
                _context3.next = 11;
                break;
              }
              _context3.next = 11;
              return this.onRetryAbort(_context3.t0);
            case 11:
              throw _context3.t0;
            case 12:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this, [[0, 5]]);
      }));
      function exec() {
        return _exec.apply(this, arguments);
      }
      return exec;
    }())
  }]);
}();
var retryAttempt = exports.retryAttempt = function retryAttempt(fn, args, opts) {
  return new Retry(fn, args, opts);
};