"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isElectron = exports.getPlatform = exports.FcrApplicationPlatform = void 0;
require("core-js/modules/es.array.find.js");
require("core-js/modules/es.array.includes.js");
require("core-js/modules/es.array.index-of.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.string.includes.js");
require("core-js/modules/esnext.async-iterator.find.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.find.js");
var isElectron = exports.isElectron = function isElectron() {
  var userAgent = navigator.userAgent.toLowerCase();
  if (userAgent.indexOf(" electron/") > -1) {
    return true;
  }
  return false;
};
var FcrApplicationPlatform = exports.FcrApplicationPlatform = /*#__PURE__*/function (FcrApplicationPlatform) {
  FcrApplicationPlatform[FcrApplicationPlatform["DESKTOP_WEB"] = 0] = "DESKTOP_WEB";
  FcrApplicationPlatform[FcrApplicationPlatform["MACOS"] = 1] = "MACOS";
  FcrApplicationPlatform[FcrApplicationPlatform["WINDOWS"] = 2] = "WINDOWS";
  FcrApplicationPlatform[FcrApplicationPlatform["IOS"] = 3] = "IOS";
  FcrApplicationPlatform[FcrApplicationPlatform["ANDROID"] = 4] = "ANDROID";
  FcrApplicationPlatform[FcrApplicationPlatform["MOBILE_WEB"] = 5] = "MOBILE_WEB";
  FcrApplicationPlatform[FcrApplicationPlatform["SIP_H322"] = 6] = "SIP_H322";
  FcrApplicationPlatform[FcrApplicationPlatform["PSTN"] = 7] = "PSTN";
  return FcrApplicationPlatform;
}({});
var getPlatform = exports.getPlatform = function getPlatform() {
  var userAgent = navigator.userAgent.toLowerCase();
  var platforms = [{
    key: 'windows',
    value: FcrApplicationPlatform.WINDOWS
  }, {
    key: 'mac',
    value: FcrApplicationPlatform.MACOS
  }, {
    key: 'android',
    value: FcrApplicationPlatform.MOBILE_WEB
  }, {
    key: 'iphone',
    value: FcrApplicationPlatform.MOBILE_WEB
  }, {
    key: 'ipad',
    value: FcrApplicationPlatform.MOBILE_WEB
  }];
  var platform = platforms.find(function (p) {
    return userAgent.includes(p.key);
  });
  if (isElectron()) {
    return platform ? platform.value : FcrApplicationPlatform.MACOS;
  }
  return platform ? platform.value : FcrApplicationPlatform.DESKTOP_WEB;
};