"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.chain = exports.Result = void 0;
var Result = exports.Result = /*#__PURE__*/function (Result) {
  Result[Result["BREAK"] = 0] = "BREAK";
  Result[Result["CONTINUE"] = 1] = "CONTINUE";
  return Result;
}({}); // simple interceptor chain that allows you to make flow control with functional programming style
var chain = exports.chain = function chain() {
  for (var _len = arguments.length, interceptors = new Array(_len), _key = 0; _key < _len; _key++) {
    interceptors[_key] = arguments[_key];
  }
  return function (evt) {
    var r = Result.CONTINUE;
    for (var i in interceptors) {
      var interceptor = interceptors[i];
      r = interceptor(evt);
      if (r === Result.BREAK) {
        break;
      }
    }
    return r;
  };
};