"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.error.cause.js");
require("core-js/modules/es.error.to-string.js");
require("core-js/modules/es.array.from.js");
require("core-js/modules/es.array.is-array.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.date.to-string.js");
require("core-js/modules/es.function.name.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/es.regexp.test.js");
require("core-js/modules/es.regexp.to-string.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zipDir = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.promise.js");
var _jszip = _interopRequireDefault(require("jszip"));
var _logger = require("../logger");
var _dayjs = _interopRequireDefault(require("dayjs"));
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var zipDir = exports.zipDir = function zipDir(dirPath) {
  var logger = (0, _logger.getLogger)();
  return new Promise(function (resolve) {
    try {
      var fs = window.require('fs');
      fs.readdir(dirPath, /*#__PURE__*/function () {
        var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(err, files) {
          var zip, _iterator, _step, _file, filePath, logsStr, blob, buffer, datefmt, file;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                if (!err) {
                  _context.next = 4;
                  break;
                }
                console.error("failed to read dir.", err);
                _context.next = 39;
                break;
              case 4:
                if (!(files.length === 0)) {
                  _context.next = 8;
                  break;
                }
                resolve(null);
                _context.next = 39;
                break;
              case 8:
                zip = new _jszip["default"]();
                _iterator = _createForOfIteratorHelper(files);
                _context.prev = 10;
                _iterator.s();
              case 12:
                if ((_step = _iterator.n()).done) {
                  _context.next = 22;
                  break;
                }
                _file = _step.value;
                filePath = "".concat(dirPath, "/").concat(_file); // check if filePath pointed to a regular file
                _context.next = 17;
                return isFile(filePath);
              case 17:
                if (!_context.sent) {
                  _context.next = 20;
                  break;
                }
                logsStr = fs.readFileSync(filePath, 'utf8');
                zip.file(_file, logsStr);
              case 20:
                _context.next = 12;
                break;
              case 22:
                _context.next = 27;
                break;
              case 24:
                _context.prev = 24;
                _context.t0 = _context["catch"](10);
                _iterator.e(_context.t0);
              case 27:
                _context.prev = 27;
                _iterator.f();
                return _context.finish(27);
              case 30:
                _context.next = 32;
                return zip.generateAsync({
                  type: 'blob'
                });
              case 32:
                blob = _context.sent;
                _context.next = 35;
                return blob.arrayBuffer();
              case 35:
                buffer = _context.sent;
                datefmt = (0, _dayjs["default"])().format('YYYY-MM-DDTHH:mm:ssZ[Z]');
                file = new File([buffer], "logs-".concat(datefmt, ".zip"), {
                  type: 'application/zip'
                });
                resolve(file);
              case 39:
              case "end":
                return _context.stop();
            }
          }, _callee, null, [[10, 24, 27, 30]]);
        }));
        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }());
    } catch (e) {
      logger.error("failed to get buffer.", e);
      resolve(null);
    }
  });
};
var isFile = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2(filePath) {
    var fs;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          fs = window.require('fs');
          return _context2.abrupt("return", new Promise(function (resolve, reject) {
            fs.stat(filePath, function (err, stats) {
              if (err) reject(err);
              resolve(stats.isFile());
            });
          }));
        case 2:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return function isFile(_x3) {
    return _ref2.apply(this, arguments);
  };
}();