import { LogWorkerInteractor } from '../logger/type';
export declare class WorkerInteractor implements LogWorkerInteractor {
    private _eventEmitter;
    private _logWorker;
    constructor();
    clearTempLogs(): Promise<void>;
    setMaxRecords(maxRecords: number): Promise<void>;
    sendLog(message: string, label: string): void;
    collectLogs(labels: string[]): Promise<{
        file: File;
        lastId: number;
    }>;
    deleteLogs(labels: string[], lastId: number): Promise<void>;
    persistBinary(id: number, buffer: Buffer): Promise<void>;
    unpersistBinary(id: number): Promise<void>;
    getBinary(id: number): Promise<Buffer<ArrayBufferLike> | null>;
    collectLogsOnFs(logDirPath: string): Promise<File>;
    private _handleMessageCallback;
    private _handleErrorCallback;
    private _handleMessageErrorCallback;
    private _attachEventHandlers;
    private _spawnNewWorker;
    private _promisify;
}
